#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <dos.h>
#include <process.h>

#define ESC   27

void main(int argc, char *args[])
{
  unsigned int hrs_real, min_real, sec_real, old_sec_real;
  unsigned int hrs_modif, min_modif, sec_modif, old_sec_modif;
  float time_coef;
  unsigned long new_const;


  clrscr();
  sscanf(args[1], "%f", &time_coef);
  if (time_coef < 1) {
  time_coef = 1;
  printf("Koeficient nemuze byt mensi nez 1.0.");
  exit(0);
  }
  new_const = 65536/time_coef - 1;

  outportb(0x43, 0x34);
  outportb(0x40, new_const%256);
  outportb(0x40, new_const/256);

  while (1) {
    _AH = 0x02;
    geninterrupt(0x1A);
    hrs_real = _CH;
    min_real = _CL;
    sec_real = _DH;

    _AH = 0x2C;
    geninterrupt(0x21);
    hrs_modif = _CH;
    min_modif = _CL;
    sec_modif = _DH;

    if ((old_sec_real != sec_real) || (old_sec_modif != sec_modif)) {
      old_sec_real = sec_real;
      old_sec_modif = sec_modif;
      clrscr();
      printf("Skutecny cas: %X:%02X:%02X; novy cas: %d:%02d:%02d.", hrs_real, min_real, sec_real, hrs_modif, min_modif, sec_modif);
    }

    if (kbhit() != 0)
      if (getch() == ESC)
	break;
  }

  outportb(0x43, 0x34);
  outportb(0x40, 0xFF);
  outportb(0x40, 0xFF);
}