#include <stdio.h>
#include <conio.h>
#include <dos.h>

typedef void interrupt (*P_PRER) (void);//typ ukazatel na obsluhu prerus.

P_PRER stara_adresa;			//promenna pro uschovu stare adresy

volatile unsigned int kusy = 0;
volatile unsigned char znacka = 1;

void interrupt port(void)		//obsluha preruseni portu
{
  kusy++;
  znacka = 1;
  (*stara_adresa)();			//volani puvodni obsluhy preruseni
  outportb(0x20,0x20);
}

void main()
{
  unsigned int i, j, bedny = 0;

  stara_adresa = getvect(0x0F);		//zjisteni stare adresy z prerusovaciho vektoru
  setvect(0x0F, port);			//zapis adresy nasi obsluhy do prerusovaciho vektoru

  i = inportb(0x21);			//zapis na port
  outportb(0x21,i & 0x7F);
  j = inportb(0x37A);			//zapis do radice preruseni
  outportb(0x37A,j | 0x10);
  outportb(0x378,0x03);

  clrscr();
  while (1) {
    if (znacka) {
      znacka = 0;
      bedny = kusy / 7;
      if (!(kusy % 7)) {
      clrscr();
      printf("Ctu %X", inportb(0x379));
      delay(5000);
      outportb(0x378,0x03);
      }
      clrscr();
      printf("Beden %d z 5, kusu %d ze 7, celkem %d.", bedny, kusy - 7*bedny, kusy);
//      sound(880); delay(50); nosound();
    }
    if (kbhit() != 0)
      if (getch() == 27)
	break;
    if (kusy == 35) {
      clrscr();
      printf("Hotovo...");
      outportb(0x378,0x02);
      while(!kbhit());
      break;
    }
  }

  outportb(0x378,0x00);
  outportb(0x21,i);			//vraceni puvodnich hodnot
  outportb(0x37A,j);
  setvect(0x0F, stara_adresa);
}